;************************************************************************
;*                         PhoneCard dumper V1.0                        *
;*                                                                      *
;*                            By Jeff                                   *
;*                                                                      *
;*                          (C) HxC2001                                 *
;*                        www.powerofasm.fr.st                          *
;*                    @:jeanfrancoisdelnero@libero.it                   *
;*                                                                      *
;************************************************************************

mov ax,cs
mov ds,ax

mov dx,378h
mov al,11111001b   ;mise sous tension
out dx,al


mov si,offset binbuffer
call Lire1Bank          ;lecture des 256 premiers bits

mov si,offset binbuffer+(256/8)
call Lire1Bank          ;lecture des 256 suivant

mov di,offset buffertxt
mov dx,offset message4   
call AfficheString


push di
mov di,offset binbuffer
mov si,offset binbuffer+(256/8)
call cmpbank            ;comparaisons
pop di

dec al                  ;al=1 alors 256bits
jz suite54646

mov dx,offset message1   ; sinon 512bits
call AfficheString
mov word ptr ds:[taillefichier],64
jmp wrgggfj456
suite54646:
mov dx,offset message2   ; sinon 512bits
call AfficheString
wrgggfj456:

mov dx,378h
mov al,0               ;mise hors tension
out dx,al

mov dx,offset message3
call AfficheString

mov si,offset binbuffer
mov cl,ds:[taillefichier]
mov ch,4

boucleaff:
mov al,ds:[si]
call AfficheBIN
add di,8
add word ptr ds:[taillefichiertxt],8
mov ax,0e20h
int 10h
mov byte ptr ds:[di],20h
add di,1
inc word ptr ds:[taillefichiertxt]
dec ch
jnz suite454613

mov byte ptr ds:[di],13
add di,1
mov byte ptr ds:[di],10
add di,1
add word ptr ds:[taillefichiertxt],2

mov ax,0e0dh
int 10h
mov al,10
int 10h

mov ch,4
suite454613:
inc si
dec cl
jnz boucleaff


mov dx,offset message5
call AfficheString

mov si,offset binbuffer
mov cl,ds:[taillefichier]
mov ch,4

boucleaffb:
mov al,ds:[si]
call AfficheHEX
add di,2
add word ptr ds:[taillefichiertxt],2
mov ax,0e20h
int 10h
mov byte ptr ds:[di],20h
add di,1
inc word ptr ds:[taillefichiertxt]
dec ch
jnz suite454613b

mov byte ptr ds:[di],13
add di,1
mov byte ptr ds:[di],10
add di,1
add word ptr ds:[taillefichiertxt],2

mov ax,0e0dh
int 10h
mov al,10
int 10h

mov ch,4
suite454613b:
inc si
dec cl
jnz boucleaffb





mov ah,3ch
mov cx,0
mov dx,offset fichier
int 21h
jc errorer

mov ds:[handle],ax
mov bx,ax
mov ah,40h
mov cx,ds:[taillefichier]
mov dx,offset binbuffer
int 21h
jc errorer

mov bx,ds:[handle]
mov ah,3eh
int 21h


mov ah,3ch
mov cx,0
mov dx,offset fichier2
int 21h
jc errorer

mov ds:[handle],ax
mov bx,ax
mov ah,40h
mov cx,ds:[taillefichiertxt]
mov dx,offset buffertxt
int 21h
jc errorer

mov bx,ds:[handle]
mov ah,3eh
int 21h

mov di,160+(80-20)*2

call LOGOTXT
mov dx,offset message6
mov ah,9
int 21h

mov ax,4c00h
int 21h
ret

errorer:
mov di,160+(80-20)*2
call LOGOTXT
mov ax,4cffh
int 21h
ret





;***************************************
Lire1Bank Proc ; ds:si = buffer (256 bit)  dx=I/O Port
pusha
mov bh,8
mov cx,256
xor bl,bl

Lire1BankBoucle:
inc dx
in al,dx
dec dx
and bl,01111111xb
and al,01000000xb
jz suite54de6
or  bl,10000000xB
jmp eferfresd
suite54de6:

eferfresd:

rol bl,1

dec bh
jnz suitekj
mov bh,8
mov ds:[si],bl
xor bl,bl
inc si
suitekj:


in al,dx
or al,00000010xb
out dx,al

in al,dx
and al,11111101xb
out dx,al

dec cx
jnz Lire1BankBoucle

POPA
RET
Lire1Bank EndP ; ds:si = buffer (256 bit)  dx=I/O Port

;*******************************************************

cmpbank proc  ;ds:si=bank1 ds:di=bank2
pusha
mov cl,256/8
bouclecmpbank:
mov al,ds:[si]
cmp al,ds:[di]
jne fincmpbank0
inc di
inc si
dec cl
jnz bouclecmpbank
popa
mov al,1
ret
fincmpbank0:
popa
mov al,0
ret
cmpbank endp  ;ds:si=bank1 ds:di=bank2

;*************************************

AfficheBIN Proc ;Al=valeur   ds:di=buffer
pusha
mov cl,10000000xb
mov bl,al
mov ah,0eh
boucleAfficheBin:
mov al,'0'
test bl,cl
jz affiche
inc al
affiche:
mov ds:[di],al
inc di
int 10h
ror cl,1
test cl,10000000xb
jz boucleAfficheBin
popa
ret
AfficheBIN endp


AfficheString Proc
push ax
push si
xor cx,cx
mov si,dx
mov ah,9h
int 21h
bouclecopyaffiche:
mov al,ds:[si]
mov ds:[di],al
cmp al,'$'
je finbouclecopyaffiche
inc cx
inc di
inc si
jmp bouclecopyaffiche

finbouclecopyaffiche:
add word ptr ds:[taillefichiertxt],cx
pop si
pop ax
ret
AfficheString EndP

AfficheHEX Proc ;Al=valeur   ds:di=buffer
pusha
mov bl,al
and bl,11110000xb
shr bl,4
cmp bl,9
ja suiteAfficheBin
add bl,'0'
jmp suite4654AfficheBin
suiteAfficheBin:
sub bl,10
add bl,'A'
suite4654AfficheBin:
mov ds:[di],bl
push ax
mov al,bl
mov ah,0eh
int 10h
pop ax

inc di
mov bl,al
and bl,00001111xb
cmp bl,9
ja suiteAfficheBinb
add bl,'0'
jmp suite4654AfficheBinb
suiteAfficheBinb:
sub bl,10
add bl,'A'
suite4654AfficheBinb:
mov ds:[di],bl
push ax
mov al,bl
mov ah,0eh
int 10h
pop ax

inc di
popa
ret
AfficheHEX endp

;///////////////////////////////////////////////////////////////////////
LOGOTXT PROC      ;DI=Position dans la mem video (nombre paire)
PUSHA
PUSH ES
mov DX,0B800h
mov ES,DX
mov SI,offset LOGO
mov CX,15          ;Taille X
mov DX,5           ;Taille Y
mov AH,01Ch        ;Couleur
mov BH,2
jp1001:
mov AL,CS:[SI]
mov ES:[DI],AX
INC SI
ADD DI,2
DEC CX
JNZ JP1001
ADD DI,80*2 - 15*2  ;Largeur X - Taille X
MOV CX,15
DEC DX
JNZ JP1001
MOV DX,1             ;Taille Y "production"
MOV AH,0Fh           ;Couleur "Production"
DEC BH
JNZ JP1001
POP ES
POPA
ret
LOGO  DB "H   H      CCC "
      DB "H   H     C   C"
      DB "HHHHH X X C    "
      DB "H   H  X  C   C"
      DB "H   H X X  CCC "
      DB "  Production   "
LOGOTXT ENDP


;*************************************
;Data

taillefichier dw 32
taillefichiertxt dw 0
handle  dw 0
message2 db "TG1 Card (256 bits)",13,10,"$"
message1 db "TG2 Card (512 bits)",13,10,"$"
message3 db 13,10,"BIN:",13,10,"$"
message5 db 13,10,"HEX:",13,10,"$"

message4 db "PhoneCard dumper V1.0 "
         db "(c) HxC2001  ->www.powerofasm.fr.st<-",13,10,13,10,"$"

message6 db "Phone-Card saved in phoncard.txt (ASCII) and in phoncard.bin (binary)...$"
fichier db "phoncard.bin",0
fichier2 db "phoncard.txt",0

binbuffer db 512 dup(0)
buffertxt db 1024 dup(0)

